import java.util.*;
import java.io.*;

/**
 * Write a description of class Vigenere here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Vigenere
{
    private String clave;     
    private Documento docOrigen; 
    private static char [][] tablaVigenere = 
      { 
      { 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'},
      { 'B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A'},
      { 'C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B'},
      { 'D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C'},
      { 'E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D'},
      { 'F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E'},
      { 'G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F'},      
      { 'H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G'},
      { 'I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H'},
      { 'J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I'},
      { 'K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J'},
      { 'L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K'},
      { 'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L'},
      { 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M'},
      { 'O','P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N'},
      { 'P','Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O'},
      { 'Q','R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P'},
      { 'R','S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q'},
      { 'S','T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R'},
      { 'T','U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S'},
      { 'U','V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T'},
      { 'V','W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U'},
      { 'W','X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V'},
      { 'X','Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W'},
      { 'Y','Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X'},
      { 'Z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y'},
      { 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'}
      };
    
      /**
      * Constructor de la clase Compresor.
      * @param nom nombre del documento
      * @param cl clave para codificar/decodificar
      */
     public Vigenere(String nom, String cl)
     {
         docOrigen = new Documento(nom);
         clave = cl;
    }
    
    /**
     * Retorna la clave de los espas para descifrar el archivo
     * @return clave par descifrar
     */
    public String getClave()
    {
        return clave;
    }

    /**
     * Asigna la clave de los espas
     * @param c nueva clave
     */
    public void setClave(String c)
    {
      clave = c;
    }
    
    /**
     * Retorna el documento origen
     * @return documento origen
     */
    public Documento getDocumentoOrigen()
    {
        return docOrigen;
    }  
    
    /**
     * Asigna un nuevo documento origen
     * @param nd nuevo documento origen
     */
    public void setDocumentoOrigen(Documento nd)
    {
      docOrigen = nd;
    } 
        
    
    /**
     * Retorna el caracter codificado de la matriz Vigenere de un caracter segn un alfabeto
     * @param clavei alfabeto usado para codificar
     * @param cari caracter a codificar segn el alfabeto clavei de la tabla de Vignere
     * @return caracter codificado, esto es, caracter en 
     * la posicin (clavei, mensajej) de la tabla de Vigenere
     */
    public char valorCodificadoVigenere(char clavei, char cari)
    {
         return tablaVigenere[clavei - 'A'][cari - 'A'];
    }
    
    /**
     * Retorna el caracter decodificado de un caracter segn un alfabeto
     * @param clavei alfabeto usado para codificar
     * @param cari caracter a decodificar segn el alfabeto clavei
     * @return caracter decodificado segn la tabla de Vigenere
     */
    public char valorDecodificadoVigenere(char clavei, char cari)
    {
        //HACER
    }                    
                
}
